<?php
/**
 * Scand_ProductLocator extension is a extension to display specific products on Product Locator.
 * Copyright (C) 2013 Scand Ltd.
 * 
 * This file is part of Scand_ProductLocator extension.
 * 
 * Scand_ProductLocator extension is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scand_ProductLocator extension is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Scand_ProductLocator extension. If not, see <http://www.gnu.org/licenses/>.
 * 
 * @category    Scand
 * @package     Scand_ProductLocator
 * @copyright   Copyright (c) 2013 Scand Ltd. (http://www.scand.com)
 * @license     http://www.gnu.org/licenses/gpl-3.0.html GNU General Public License (GPL 3.0)
 */

class Scand_ProductLocator_Model_Observer {
	static protected $_isSingleton = false;
	
	public function saveProductTabData(Varien_Event_Observer $observer) {
		if (!self::$_isSingleton) {
			self::$_isSingleton = TRUE;
			
			$product = $observer->getEvent()->getProduct();
			
			try {
				$productAddress = Mage::getModel('productlocator/product_address')
					->setCountryId(Mage::helper('core')->getDefaultCountry($product->getStore()))
					->loadByProduct($product->getId());
				
				$postData = $this->_getRequest()->getPost('product');
				$addressFormData = $postData[$productAddress->addressFormPrefix];
				
				$productAddress->setData($productAddress->appendIds($addressFormData))
					->implodeStreetAddress()
					->save();
				
				$this->_getSession()->setAddressFormData(NULL);
			}
			catch (Exception $e) {
				$this->_getSession()
					->setAddressFormData($this->_getRequest()->getPost())
					->addError($e->getMessage());
			}
		}
	}
	
	protected function _getSession() {
		return Mage::getSingleton('adminhtml/session');
	}

	protected function _getRequest() {
		return Mage::app()->getRequest();
	}

	protected function _getResponse() {
		return Mage::app()->getResponse();
	}
}